; ----------------------------------------------------------------
;
; BLASTER.ASM				O.Singla	-	Feb 1998
;
; Functions to draw a bitmap into memory.
;
; ----------------------------------------------------------------

		.386p

; Transparent color
;		(could be a parameter in a future version)
BLACK	equ	0

; Where to put the bitmap (memory)
; 		(variable defined into the C module)
extrn	_work_frame:	dword

; Scrolling Active ?
; 		(variables defined into the C module)
extrn	_is_scrolling_lr:	dword
extrn	_is_scrolling_bt:	dword

; Size of the frame
;		(used for scrolling)
extrn	_frame_width:	dword
extrn	_frame_height:	dword
extrn	_frame_size:	dword

; Exported functions (to be used from C code)
global 	blaster_copy_:	proc
global 	blaster_or_:	proc
global 	blaster_xor_:	proc


; ----------------
; Clear a register
; ----------------
clr		macro	reg
		xor		reg, reg
		endm


; ------------------------------
; Local variables to this module
; ------------------------------

_DATA	segment para public use32

xstart	dd		0
ystart	dd		0

x		dd		0
y		dd		0

height	dw		0			; Height of the bitmap

_DATA	ends
	

_TEXT	segment para public use32
		assume cs:code32, ds:code32, ss:code32

; ---------------------------------------------------------------------------------------------
; I)	ESI:	bitmap (addr) source
;		EAX:	dw	(width of the bitmap,  16-bits)
;		EBX:	dh	(height of the bitmap, 16-bits)
;		ECX:	px	(where to put the bitmap into the frame, 16-bits)
;		EDX:	py	idem...
;		
; O)	none
; ---------------------------------------------------------------------------------------------

blaster				macro	OP

					local	next_line, next_line0, next_line2
					local	copy_line, copy_line2, copy_line3, copy_line4, copy_line5

					; Save some vital registers, used by C-Runtime
					push	ebp
					push	edi

					; Save (px, py)
					mov		[ystart], edx
					mov		[xstart], ecx

					; Compute starting address into the frame target
					mov		edi, edx							; Get py
					imul	edi, [_frame_width]
					add		edi, ecx							; Add px
					add		edi, [_work_frame]

					mov		ebp, eax							; DW
										
					clr		ecx									; Row counter
					mov		eax, [ystart]
					mov		[y], eax

next_line:			
					mov		eax, [y]
					or		eax, eax
					jl		next_line2
					cmp		eax, [_frame_height]
					jl		next_line0

					; Flood on bottom
					test	byte ptr [_is_scrolling_bt], 1
					jz		next_line2
					sub		edi, [_frame_size]
					mov		edx, [_frame_height]
					sub		[y], edx

next_line0:			clr		edx									; Column counter
					mov		eax, [xstart]
					mov		[x], eax

copy_line:			cmp		byte ptr [esi + edx ], BLACK		; Transparent ?
					je		copy_line2

					mov		eax, [x]							; Test left
					or		eax, eax
					jl		copy_line5
					cmp		eax, [_frame_width]
					jl		copy_line3

					; Flood on right
copy_line4:			test	byte ptr [_is_scrolling_lr], 1
					jz		copy_line2
					mov		al, [esi + edx]
					sub		edx, [_frame_width]
					OP		[edi + edx], al
					add		edx, [_frame_width]
					jmp		copy_line2

					; Flood on left
copy_line5:			test	byte ptr [_is_scrolling_lr], 1
					jz		copy_line2
					mov		al, [esi + edx]
					add		edx, [_frame_width]
					OP		[edi + edx], al
					sub		edx, [_frame_width]
					jmp		copy_line2

copy_line3:			mov		al, [esi + edx]
					OP		[edi + edx], al

copy_line2:			inc		[x]
					inc		edx
					cmp		dx, bp
					jne		copy_line

next_line2:			inc		[y]
					add		esi, ebp
					add		edi, [_frame_width]
					inc		ecx
					cmp		cx, bx
					jne		next_line

					; Restore some vital registers, used by C-Runtime
					pop		edi
					pop		ebp

					ret
					endm



blaster_copy_		proc
					blaster	mov
blaster_copy_		endp


blaster_or_			proc
					blaster	or
blaster_or_			endp


blaster_xor_		proc
					blaster	xor
blaster_xor_		endp


_TEXT		ends
			end
