// ============================================================================================
// ===																						===
// === config.c																				===
// ===																						===
// === Functions defined:																	===
// ===		update_config_file																===
// ===		readandset_cfg_szpos															===
// ===																						===
// ============================================================================================

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <stdarg.h>
#include <process.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "phreshold.h"
#include "abimport.h"
#include "proto.h"


int update_config_file( void )
	{
	char		temp[ 100 ];
	PtArg_t		args[ 1 ];
	PhArea_t	*area;
	int			x, y;

	/*--- Open the configuration file ---*/	
	if ( PxConfigOpen( ini_fname, PXCONFIG_WRITE ) == Pt_FALSE )
		return -1;

	/*--- Windows Size and Position ---*/	
	PxConfigSection( CFG_SECTION_WINSZPOS );

	/*--- The main window: position and size ---*/
	PtSetArg( &args[ 0 ], Pt_ARG_AREA, &area, 0 );
	PtGetResources( ABW_phreshold, 1, args );
	force_coord_into_console( area->pos.x, area->pos.y, &x, &y );
	sprintf( temp, "%d,%d,%d,%d", 
		x, y,
		area->size.w, area->size.h );
	PxConfigWriteString( CFG_SECTION_WINSZPOS, "Main window", PXCONFIG_FMT_STRING, temp );

	/*--- Close the configuration file ---*/
	PxConfigClose();

	/*--- Ok ---*/
	return 0;		

	}	// update_config_file


int readandset_cfg_szpos( char *section, PtWidget_t *wgt )
	{
	char		temp[ 100 ];
	PtArg_t		args[ 2 ];
	PhPoint_t	pos, dim;

	/*--- Open the configuration file ---*/	
	if ( PxConfigOpen( ini_fname, PXCONFIG_READ ) == Pt_FALSE )
		return -1;

	/*--- Windows Size and Position ---*/	
	PxConfigSection( CFG_SECTION_WINSZPOS );
	if ( PxConfigReadString( CFG_SECTION_WINSZPOS, section, "", 
		temp, sizeof( temp ) - 1 ) == NULL )
		{
		PxConfigClose();
		return -1;
		}
	else
		if ( sscanf( temp, "%d,%d,%d,%d", &pos.x, &pos.y, 
			&dim.x, &dim.y ) != 4 )
			{
			PxConfigClose();
			return -1;
			}

	/*--- Close the configuration file ---*/
	PxConfigClose();

	/*--- Set now the original dimension and position of the window ---*/
	PtSetArg( &args[ 0 ], Pt_ARG_POS, &pos, 0 );
	PtSetArg( &args[ 1 ], Pt_ARG_DIM, &dim, 0 );
	PtSetResources( wgt, 2, args );
	PtConsoleSwitch( 0 );
	
	return 0;
	
	}	// readandset_cfg_szpos
