#
# Application Makefile   
#

ifndef DEBUG
DEBUG = -g
endif

ifndef OPTIM
OPTIM = -Osax
endif

PLATFORM=default
PHABOPTS=

all : phreshold phreshold_kbd

#
ASFLAGS	= -g -Q -5 -mf -w5 -c
CFLAGS  = -5 -mf -w5 -v$(PLATFORM) $(OPTIM) $(DEBUG) $(PHABOPTS) -Q
CPPFLAGS = $(CFLAGS)
LDFLAGS = -Q -v$(PLATFORM) -5 -mf $(DEBUG) -l Aplib -l phrtlib -l phexlib -l phcontrib -l photon   -l phrender_s $(PHABOPTS)  "-Wl,op symf"
SDFLAGS = -Q -v$(PLATFORM) -5 -mf $(DEBUG) -l Aplib -l phrtlib -l phexlib -l phcontrib -l photon_s -l phrender_s $(PHABOPTS)  "-Wl,op symf"

SDFLAGT = -Q -v$(PLATFORM) -5 -mf $(DEBUG) -l phrtlib -l phexlib -l phcontrib -l photon_s -l phrender_s  "-Wl,op symf"

VPATH = ../.

include	../abOfiles
include ../indOfiles
MYOBJ = utils.o config.o blaster.o rnd.o ships.o shells.o missile.o cannon.o \
		fuel.o laser.o levels.o stars.o

include	../abSfiles
include ../indSfiles
MYSRC = ../utils.c ../config.c ../blaster.asm ../rnd.asm ../ships.c ../cannon.c \
		../shells.c ../missile.c ../fuel.c ../laser.c ../levels.c ../stars.c

include	../abHfiles
include ../indHfiles
MYHDR = phreshold.h

include	../abWfiles

phreshold.o			: levels.h phreshold_kbd.h

phreshold_kbd.c		: phreshold_kbd.h
phreshold_kbd.o		: phreshold_kbd.c

#
# Application Program
#

shr:	$(ABOBJ) $(MYOBJ) phreshold_kbd.o
		$(LD) $(SDFLAGS) $(ABOBJ) $(MYOBJ) -o phreshold
		usemsg phreshold ../Usemsg
		phabbind phreshold $(ABMOD)
		cp phreshold ../..
		$(LD) $(SDFLAGT) phreshold_kbd.o -o phreshold_kbd
		cp phreshold_kbd ../..

app:	$(ABOBJ) $(MYOBJ)
		$(LD) $(LDFLAGS) $(ABOBJ) $(MYOBJ) -o phreshold
		usemsg phreshold ../Usemsg
		phabbind phreshold $(ABMOD)
		cp phreshold ../..

clean:
		rm -f *.o *.err *.map *.sym phreshold phreshold_kbd \
		   ../phreshold.ini ../../phreshold.ini

install:
		-cp -vnf phreshold /usr/bin/photon

#
# Headers
#

$(ABOBJ) $(MYOBJ):	$(MYHDR)

#
# Prototype Generation
#

proto:
		approto -p $(ABSRC) $(MYSRC) > proto.h
