
/* ../abmain.c */
void main ( int argc , char *argv []);

/* ../menu.c */
int about_setup ( PtWidget_t *link_instance , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int menu_about_phreshold ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int menu_file_exit ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
void restart_same_level ( const IBOOL start_a_cannon );
void start_new_level ( const IBOOL start_a_cannon );
void start_play ( void );
int menu_file_play ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../phreshold.c */
PhImage_t *load_bitmap ( const char *bitmap_name );
void set_min_size ( void );
void set_max_size ( void );
void slog ( const char *fmt , ...);
#endif int phreshold_init ( int argc , char *argv []);
void refresh_frame ( const BOOL on );
int phreshold_setup ( PtWidget_t *link_instance , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
int phreshold_destroyed ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );
void draw_score ( void );
void drawFrame ( void );
void freeze ( void );
void unfreeze ( void );
int phreshold_window ( PtWidget_t *widget , ApInfo_t *apinfo , PtCallbackInfo_t *cbinfo );

/* ../utils.c */
int message ( const char *title , const char *fmt , ...);
void setString ( const PtWidget_t *wgt , const char *fmt , ...);
void setPos ( const PtWidget_t *wgt , const int x , const int y );
void moveBy ( const PtWidget_t *wgt , const int dx , const int dy );
void setByDim ( const PtWidget_t *wgt , const int w , const int h );
void setCursorType ( const PtWidget_t *wgt , int type );
void setGauge_MinMax ( const PtWidget_t *wgt , const int vmin , const int vmax , const int vcurr );
int getGauge_value ( const PtWidget_t *wgt );
void setGauge_value ( const PtWidget_t *wgt , const int value );
void setGauge_color ( const PtWidget_t *wgt , const PgColor_t color );
PgColor_t getGauge_color ( const PtWidget_t *wgt );
void window_focus ( PtWidget_t *wgt );
int blockWindow ( const PtWidget_t *wgt , const BOOL state );
void Bezier ( double *x , double *y , double u , int n , PhPoint_t *cc );
void BSpline ( double *x , double *y , double u , int n , int k , PhPoint_t *cc );
void RectUnion ( PhRect_t *r , const PhRect_t *r1 , const PhRect_t *r2 );
int force_coord_into_console ( int x , int y , int *px , int *py );

/* ../config.c */
int update_config_file ( void );
int readandset_cfg_szpos ( char *section , PtWidget_t *wgt );

/* ../blaster.asm */

/* ../rnd.asm */

/* ../ships.c */
void make_hit_bitmap ( const UBYTE *src , const int sz , const int nb_rem );
void init_gen_ships ( void );
void is_cannon_hit_by_ship ( SHIP *ship );
void move_ships ( void );
void ship_is_hit ( SHIP *ship );

/* ../cannon.c */
void start_new_cannon ( void );
void move_starting_cannon ( void );
void draw_cannon ( void );
void cannon_is_hit ( void );

/* ../shells.c */
void drop_shell ( const SHIP *ship );
void move_shells ( void );

/* ../missile.c */
void launch_missile ( void );
void draw_missile ( void );

/* ../fuel.c */
void update_fuel ( void );

/* ../laser.c */
void update_laser ( void );

/* ../levels.c */
void level2_pos_funct ( CONF_SHIP *des );

/* ../stars.c */
void put_stars ( void );
void draw_stars ( void );
