; ----------------------------------------------------------------
;
; FASTDRAW.ASM				O.Singla	-	Feb 1998
;
; Functions to draw the frame directly into the video memory.
;
; ----------------------------------------------------------------

		.386p

; Size of the frame
FRAME_WIDTH		equ	480
FRAME_HEIGHT	equ	360

; Where to put the frame into the video memory
; 		(variable defined into the C module)
extrn	_frame:			dword
extrn	_vmem_frame:	dword

; Exported function (to be used from C code)
global 	fastdraw_frame_:	proc



_TEXT	segment para public use32
		assume cs:code32, ds:code32, ss:code32

; ---------------------------------------------------------------------------------------------
; I)	ESI:	bitmap (addr) source
;		EAX:	dw	(width of the bitmap,  16-bits)
;		EBX:	dh	(height of the bitmap, 16-bits)
;		ECX:	px	(where to put the bitmap into the frame, 16-bits)
;		EDX:	py	idem...
;		
; O)	none
; ---------------------------------------------------------------------------------------------

fastdraw_frame_		proc

					; Save some vital registers, used by C-Runtime
					push	esi
					push	edi

					mov		esi, [_frame]
					mov		edi, [_vmem_frame]
					cld

					mov		ebx, FRAME_HEIGHT

fastdraw:			mov		ecx, FRAME_WIDTH/4
					rep movsd

					add		edi, 1280-FRAME_WIDTH
					dec		ebx
					jne		fastdraw			
			
					; Restore some vital registers, used by C-Runtime
					pop		edi
					pop		esi

					ret

fastdraw_frame_		endp


_TEXT		ends
			end
