// ============================================================================================
// ===																						===
// === fuel.c																				===
// ===																						===
// === Functions defined:																	===
// ===		update_fuel																		===
// ===																						===
// ============================================================================================

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "phreshold.h"
#include "abimport.h"
#include "proto.h"


void update_fuel( void )
	{

	/*--- Compute new level of fuel ---*/
	if ( (fuel.level = fuel.nb_clocks - (clock() - fuel.start)) < 0 )
		fuel.level = 0;
	if ( fuel.level != getGauge_value( ABW_phreshold_fuel ) )
		setGauge_value( ABW_phreshold_fuel, fuel.level );

	/*--- Out of fuel ? ---*/
	if ( !fuel.level )
		{
		refresh_frame( FALSE );
		setString( ABW_phreshold_msg, 
			"OUT OF FUEL !\nAll the galaxy curse your name now..." );
		}

	}	// update_fuel
