// ============================================================================================
// ===																						===
// === laser.c																				===
// ===																						===
// === Functions defined:																	===
// ===		update_laser																	===
// ===																						===
// ============================================================================================

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "phreshold.h"
#include "abimport.h"
#include "proto.h"


void update_laser( void )
	{
	int			nb_clocks;
	PgColor_t	color;

	/*--- Update laser level ---*/
	if ( (nb_clocks = (clock() - laser.prev_clock)) == 0 )
		return;
	laser.prev_clock = clock();
	if ( (laser.level -= (nb_clocks * laser.per_clock)) < 0 )
		laser.level = 0;
	if ( laser.level != getGauge_value( ABW_phreshold_laser ) )
		setGauge_value( ABW_phreshold_laser, laser.level );

	/*--- Overheat ? ---*/
	if ( laser.level >= LASER_OVERHEAT )
		laser.overheat = TRUE;
	else 
		if ( laser.level <= LASER_OK )
			laser.overheat = FALSE;
	color = (laser.overheat) ? Pg_RED : Pg_BLUE;
	if ( getGauge_color( ABW_phreshold_laser ) != color )
		{
		setGauge_color( ABW_phreshold_laser, color );	
		if ( laser.overheat )
			setString( ABW_phreshold_msg, "Laser overheat !" );
		else
			setString( ABW_phreshold_msg, "Laser back to normal !" );
		}
	
	}	// update_laser
