; ----------------------------------------------------------------
;
; RND.ASM
;
; Generate a pseudo-random value between two values.
;
; ----------------------------------------------------------------

		.386p


; Exported functions (to be used from C code)
global 	rnd_:	proc


; ----------------
; Clear a register
; ----------------
clr		macro	reg
		xor		reg, reg
		endm


; -----------------------------
; Local variable to this module
; -----------------------------

_DATA	segment para public use32

seed		dd		1961		; Well, I was born on May 23th, 1961...

save_ebx	dd	0

_DATA	ends
	

_TEXT	segment para public use32
		assume cs:code32, ds:code32, ss:code32

; ---------------------------------------------------------------------------------------------
; I)	EBX:	n1	
;		ECX:	n2
;		
; O)	EDX:	n3
; ---------------------------------------------------------------------------------------------

rnd_		proc

			; Compute new seed
			mov		[save_ebx], ebx
			mov		eax, [seed]
			mov		ebx, 015A4E35h
			mul		ebx					; EDX:EAX = M * seed
			inc		eax
			mov		[seed], eax
		
			; Compute limit
			sub		ecx, [save_ebx]
			inc		ecx

			; Return value
			clr		edx
			shr		eax, 16
			div		ecx					; eax(Q):edx(R) = EDX:EAX / ecx
			add		edx, [save_ebx]
			ret

rnd_		endp


_TEXT		ends
			end
