// ============================================================================================
// ===																						===
// === fuel.c																				===
// ===																						===
// === Functions defined:																	===
// ===		update_fuel																		===
// ===																						===
// ============================================================================================

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "phreshold.h"
#include "abimport.h"
#include "proto.h"


void put_stars( void )
	{
	STAR		*star;
	int			n;

	nb_stars = rnd( 4, MAXNB_STARS );
	for ( star = stars, n = 0; n < nb_stars; n++, star++ )
		{
		star->x = rnd( STAR_WIDTH + 1,  frame_width - STAR_WIDTH - 1);
		star->y = rnd( STAR_HEIGHT + 1, frame_height - STAR_HEIGHT - 1);
		star->state = rnd( 1, STAR_NBSTATES-2 );
		star->inc   = 2*rnd( 0, 1) - 1;
		star->speed = rnd( 5, 25 );
		star->speed_cnt = 1;
		}

	}	// put_stars


void draw_stars( void )
	{
static	STAR		*star;
static	int			n;

	for ( star = stars, n = 0; n < nb_stars; n++, star++ )
		{

		/*--- Draw the star to the frame buffer ---*/
		blaster_or( star_img[ star->state ],
			STAR_WIDTH, STAR_HEIGHT,
			star->x, star->y );

		/*--- Compute the new state of the ship ---*/
		if ( rnd( 0, 10 ) == 5 )
			{
			if ( star->inc == 1 )
				{
				if ( ++star->state == STAR_NBSTATES )
					{
					star->state -= 2;
					star->inc = -1;
					}
				}
			else
				{
				if ( !star->state-- )
					{
					star->state += 2;
					star->inc = 1;
					}
				}
			}

		/*--- Move down the star ? ---*/
		if ( !star->speed_cnt-- )
			{
			star->speed_cnt = star->speed;
			if ( --star->y < 0 )
				{
				star->x = rnd( STAR_WIDTH + 1, frame_width - STAR_WIDTH - 1);
				star->y = frame_height - STAR_HEIGHT;
				star->state = rnd( 1, STAR_NBSTATES-2 );
				star->inc   = 2*rnd( 0, 1) - 1;
				star->speed = rnd( 5, 15 );
				star->speed_cnt = 1;
				}
			}

		}	// for (star)
	
	}	// draw_stars
